

// --------
// Question 1 : Simulation d'une partie avec différents paramètres

a = 10; b = 20; p = 0.5;
[X,S,l] = jeu(a,b,p);
plot2d(0:l,S,rect=[0 0 l b])
title(["Une partie, p="+string(p)])

a = 10; b = 20; p = 0.3;
[X,S,l] = jeu(a,b,p);
plot2d(0:l,S,rect=[0 0 l b])
title(["Une partie, p="+string(p)])

a = 80; b = 100; p = 0.3;
[X,S,l] = jeu(a,b,p);
plot2d(0:l,S,rect=[0 0 l b])
title(["Une partie, p="+string(p)])

// ---------
// Cas p <> q

// ---------
// Question 6 :

// Estimation de la durée moyenne d'une partie
a=10; b=20; p=1/3;
ns = 10000; // nb d'échantillons
[dme,pre] = estim_dureemoy_pruine(a,b,p,ns);
disp(['Estimation durée moyenne = '+string(dme)]);
disp(['Estimation proba de ruine = '+string(pre)]);

// Comparison aux valeurs théoriques
[dm,pr] = dureemoy_pruine(a,b,p)
disp(['Durée moyenne = '+string(dm)])
disp(['Proba ruine = '+string(pr)])


// --------
// Question 7 :

// Histogramme durée des parties pour differentes valeurs de p
ns = 100000; // nombre d'échantillons
p = 1/3;
histo_durees(a,b,p,ns);

p = 2/3;
histo_durees(a,b,p,ns);

p = 0.5;
histo_durees(a,b,p,ns);

p = 0.01;
histo_durees(a,b,p,ns);

// Courbe des durées en fct de p (attention, simu un peu longue)
pstep = 0.01;
ns = 10000;
ptab = pstep:pstep:1-pstep; np = length(ptab);
dtab = zeros(1,np);
prtab = zeros(1,np);
for ind=1:np
    [dme,pre] = estim_dureemoy_pruine(a,b,ptab(ind),ns);
    dtab(ind) = dme;
    prtab(ind) = pre;
end
// durée moyenne théorique & probabilité ruine théorique
pp = linspace(0,1,1000); pp = pp(2:$-1);
[dth,prth] = dureemoy_pruine(a,b,pp);
dth = 1 ./(pp-qq).*( b*(1-(qq./pp).^a)./(1-(qq./pp).^b) - a);
prth = 1-(1-(qq./pp).^a)./(1-(qq./pp).^b);

// Visualisation durées
plot2d(pp,dth,5)
plot2d(ptab,dtab,2)
title('Estimation de la durée d''une partie')
xlabel('p')
ylabel('durée')
// les lignes suivantes permettent d'améliorer la visualisation
//      (leur compréhension n'est pas prioritaire)
gaxes = gca();
// attention à l'ordre de placement des objets dans le handle a ...
// (vérifier l'ordre en tapant gaxes dans la console)
courbe1 = gaxes.children(1).children(1);
courbe2 = gaxes.children(2).children(1);
courbe1.thickness = 2;
courbe2.thickness = 3;
legend(['durée théorique';'durée estimée']);


// Visualisation probabilité de ruine
figure
plot2d(pp,prth,5)
plot2d(ptab,prtab,2)
title('Estimation de la probabilité de ruine')
xlabel('p')
ylabel('\mathbb{P}(ruine)')
gaxes = gca();
// attention à l'ordre de placement des objets dans le handle a ...
// (vérifier l'ordre en tapant gaxes dans la console)
courbe1 = gaxes.children(1).children(1);
courbe2 = gaxes.children(2).children(1);
courbe1.thickness = 2;
courbe2.thickness = 3;
legend(['probabilité théorique';'probabilité estimée']);


//---------
// Cas p = q
// Question 8

a=10; b=20; p=0.5;
ns = 10000; // nb d'échantillons
[dme,pre] = estim_dureemoy_pruine(a,b,p,ns);
disp(['Durée moyenne estimée = '+string(dme)]);
disp(['Proba de ruine estimée = '+string(pre)]);

// Comparison aux valeurs théoriques
pr = (b-a)/b;
dm = a*(b-a);
disp(['Durée moyenne = '+string(dm)])
disp(['Proba ruine = '+string(pr)])
